## gnucash 2.6.19

=== checks/CMakeLists.txt ===
SET(checks_DATA
  deluxe.chk
  liberty.chk
  quicken.chk
  quicken_wallet.chk
  voucher.chk
  quicken_check_21.chk
  quicken_3part.chk
)

INSTALL(FILES ${checks_DATA} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/gnucash/checks)

FILE(COPY ${checks_DATA} DESTINATION ${DATADIR_BUILD}/gnucash/checks)

SET_DIST_LIST(checks_DIST CMakeLists.txt Makefile.am ${checks_DATA})

=== cmake/CMakeLists.txt ===
# Post install actions go here.

IF (APPLE)
  INSTALL(CODE "EXECUTE_PROCESS(
                COMMAND /usr/bin/install_name_tool -add_rpath ${CMAKE_INSTALL_PREFIX}/lib
                                                   -add_rpath ${CMAKE_INSTALL_PREFIX}/lib/gnucash
                                                   ${CMAKE_INSTALL_PREFIX}/bin/gnucash)")
ENDIF(APPLE)


SET(CMAKE_COMMAND_TMP "")
IF (${CMAKE_VERSION} VERSION_GREATER 3.1)
  SET(CMAKE_COMMAND_TMP ${CMAKE_COMMAND} -E env)
ENDIF()

SET(schema-targets business-gnome-gschema csv-exp-gschema csv-imp-gschema
    generic-import-gschema gnome-gschema gnome-utils-gschema qif-imp-gschema)

IF (WITH_AQBANKING)
  LIST(APPEND schema-targets aqb-gschema)
ENDIF (WITH_AQBANKING)
    
IF (WITH_OFX)
  LIST(APPEND schema-targets ofx-gschema)
ENDIF (WITH_OFX)
    
SET(SCHEMA_BUILD_DIR ${DATADIR_BUILD}/glib-2.0/schemas)
ADD_CUSTOM_COMMAND(
  OUTPUT ${SCHEMA_BUILD_DIR}/gschemas.compiled
  COMMAND ${CMAKE_COMMAND_TMP} ${GLIB_COMPILE_SCHEMAS} ${SCHEMA_BUILD_DIR}
  DEPENDS ${schema-targets}
)

ADD_CUSTOM_TARGET(compiled-schemas ALL DEPENDS ${SCHEMA_BUILD_DIR}/gschemas.compiled)

INSTALL(FILES ${SCHEMA_BUILD_DIR}/gschemas.compiled DESTINATION ${DATADIR}/glib-2.0/schemas)

SET_DIST_LIST(cmake_DIST CMakeLists.txt README_CMAKE.txt cmake_uninstall.cmake.in)

=== doc/CMakeLists.txt ===
ADD_SUBDIRECTORY(examples)

SET(doc_DATA
  README.francais
  README.german
  README-ca.win32-bin.txt
  README-de.win32-bin.txt
  README-fr.win32-bin.txt
  README-it.win32-bin.txt
  README-lv.win32-bin.txt
  README-nl.win32-bin.txt
  README-zh_CN.win32-bin.txt
  README-zh_TW.win32-bin.txt
  README.win32-bin.txt
  guile-hackers.txt
  projects.html
)

SET(doc_noinst_DATA
        build-aix.txt build-solaris.txt CMakeLists.txt gnc-fq-dump.1 gnc-fq-helper.1 gnucash.1.in gtkrc-2.0.gnucash
        Makefile.am misc-notes.txt README.build-system README.HBCI README.OFX README.translator.txt tip_of_the_day.list.in
        TRANSLATION_HOWTO)

INSTALL(FILES ${doc_DATA} DESTINATION share/doc/gnucash)

SET_LOCAL_DIST(doc_DIST_local ${doc_DATA} ${doc_noinst_DATA})
SET(doc_DIST ${doc_DIST_local} ${examples_DIST} PARENT_SCOPE)

FILE(COPY ${doc_DATA} DESTINATION ${DATADIR_BUILD}/doc/gnucash)

IF (${CMAKE_VERSION} VERSION_GREATER 3.1)
  EXECUTE_PROCESS(
    COMMAND ${CMAKE_COMMAND} -E  env date +"%B %Y"
    OUTPUT_VARIABLE DATE_IN
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
ELSE()
  EXECUTE_PROCESS(
    COMMAND date +"%B %Y"
    OUTPUT_VARIABLE DATE_IN
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
ENDIF()

# Remove any quotes present in the DATE string
STRING(REGEX REPLACE "\"" "" DATE "${DATE_IN}")

# Generate the tip of the day file.

EXECUTE_PROCESS(
    COMMAND ${CMAKE_C_COMPILER} -E -P -x c -DN_\(x\)=x -o ${CMAKE_CURRENT_BINARY_DIR}/tip_of_the_day.list.tmp ${CMAKE_CURRENT_SOURCE_DIR}/tip_of_the_day.list.in
)

FILE(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/tip_of_the_day.list.tmp TIP_OF_THE_DAY_LINES)

SET(TOTD_OUTPUT "")
FOREACH(line ${TIP_OF_THE_DAY_LINES})
  STRING(REGEX REPLACE "^ *\"" "" line2 "${line}")
  STRING(REGEX REPLACE "\" *$" "" line3 "${line2}")
  LIST(APPEND TOTD_OUTPUT "${line3}\n")
ENDFOREACH()

LIST(APPEND TOTD_OUTPUT "\n")

STRING(CONCAT FINAL_TOTD ${TOTD_OUTPUT})

FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/tip_of_the_day.list "${FINAL_TOTD}")

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/tip_of_the_day.list DESTINATION share/gnucash)

FILE(COPY ${CMAKE_CURRENT_BINARY_DIR}/tip_of_the_day.list
  DESTINATION ${DATADIR_BUILD}/gnucash)

# ---

GNC_CONFIGURE(gnucash.1.in gnucash.1 )
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnucash.1 DESTINATION share/man/man1)

FILE(COPY ${CMAKE_CURRENT_BINARY_DIR}/gnucash.1
  DESTINATION ${DATADIR_BUILD}/gnucash)

=== lib/CMakeLists.txt ===
ADD_SUBDIRECTORY(libc)
ADD_SUBDIRECTORY(stf)

SET_LOCAL_DIST(lib_DIST_local CMakeLists.txt Makefile.am README)
SET(lib_DIST ${lib_DIST_local} ${libc_DIST} ${stf_DIST} PARENT_SCOPE)

=== macros/CMakeLists.txt ===

SET_DIST_LIST(macros_DIST ax_pkg_swig.m4 ax_python_devel.m4 ax_swig_python.m4 binreloc.m4
                           compiler-flags.m4 CMakeLists.txt legacy_macros.m4 pkg.m4)

=== packaging/CMakeLists.txt ===

GNC_CONFIGURE(gnucash.spec.in gnucash.spec)

SET_DIST_LIST(packaging_DIST CMakeLists.txt gnucash.spec.in Makefile.am)

=== po/CMakeLists.txt ===
ADD_SUBDIRECTORY(glossary)

# Set of available languages.
SET (TP_LINGUAS az ca cs da eu fa ja nl rw sk sr sv tr uk zh_CN)
# already marked as external at TP:
SET (GC_LINGUAS ar bg de el en_GB es fi fr gu he hi hu it kn ko lt lv mr nb ne pl pt pt_BR ro ru ta te ur vi zh_TW)
# not marked or no TP team:
SET (NEW_LINGUAS as brx doi es_NI kok kok@latin ks mai mni mni@bengali)

SET (ALL_LINGUAS ${TP_LINGUAS} ${GC_LINGUAS} ${NEW_LINGUAS})

SET (CATALOGS "")
SET (BUILD_CATALOGS "")

SET(CMAKE_COMMAND_TMP "")
IF (${CMAKE_VERSION} VERSION_GREATER 3.1)
  SET(CMAKE_COMMAND_TMP ${CMAKE_COMMAND} -E env)
ENDIF()

SET(po_SOURCES "")
FOREACH(lingua ${ALL_LINGUAS})
  LIST(APPEND po_SOURCES ${lingua}.po)
ENDFOREACH()

SET_LOCAL_DIST(po_DIST_local ${po_SOURCES} CMakeLists.txt ChangeLog Makevars POTFILES.ignore POTFILES.in POTFILES.skip
        README check-po.cmake)
SET(po_DIST ${po_DIST_local} ${po_glossary_DIST} PARENT_SCOPE)

FOREACH(lingua ${ALL_LINGUAS})
  SET(_OUTPUT_FILE ${lingua}.mo)
  LIST(APPEND CATALOGS ${_OUTPUT_FILE})
  ADD_CUSTOM_COMMAND(
      OUTPUT ${_OUTPUT_FILE}
      COMMAND ${CMAKE_COMMAND_TMP} ${MSGFMT} -o ${_OUTPUT_FILE} ${CMAKE_CURRENT_SOURCE_DIR}/${lingua}.po
  )
  SET(_BUILD_FILE_DIR ${DATADIR_BUILD}/locale/${lingua}/LC_MESSAGES)
  MAKE_DIRECTORY(${_BUILD_FILE_DIR})
  SET(_BUILD_FILE ${_BUILD_FILE_DIR}/gnucash.mo)
  LIST(APPEND BUILD_CATALOGS ${_BUILD_FILE})
  ADD_CUSTOM_COMMAND(
    OUTPUT ${_BUILD_FILE}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/${lingua}.mo ${_BUILD_FILE}
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${_OUTPUT_FILE}
    #APPEND
  )
ENDFOREACH(lingua)

ADD_CUSTOM_TARGET(po-gmo ALL DEPENDS ${CATALOGS})
ADD_CUSTOM_TARGET(po-gmo-build ALL DEPENDS ${BUILD_CATALOGS})


FOREACH(lingua ${ALL_LINGUAS})
  INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${lingua}.mo RENAME gnucash.mo DESTINATION share/locale/${lingua}/LC_MESSAGES)
ENDFOREACH(lingua)


FUNCTION(READ_FILE_REMOVING_COMMENTS OUTPUT PATH)
  SET(RESULT "")
  FILE(STRINGS "${PATH}" LINES_IN)
  FOREACH(line ${LINES_IN})
    STRING(REGEX REPLACE "#.*" "" line2 ${line})
    LIST(APPEND RESULT ${line2})
  ENDFOREACH()
  SET(${OUTPUT} ${RESULT} PARENT_SCOPE)
ENDFUNCTION()


FUNCTION(MAKE_GNUCASH_POTFILES)

  SET(IGNORE_PATTERNS "gw-" "test" "experimental" "python-bindings" "swig-.*\\.c")
  
  # Create a list of candidate translation files
  FILE(GLOB_RECURSE FILES_IN RELATIVE ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/*.c ${CMAKE_SOURCE_DIR}/*.glade ${CMAKE_SOURCE_DIR}/*.desktop.in
    ${CMAKE_SOURCE_DIR}/*.keys.in  ${CMAKE_SOURCE_DIR}/*.gschema.xml.in.in ${CMAKE_SOURCE_DIR}/*.scm)

  # Only consider files in the src/ directory. Also check against list of ignore patterns
  SET(FILES "")
  FOREACH(path ${FILES_IN})
    STRING(REGEX MATCH "^src" IS_SRC ${path})
    IF (IS_SRC)
      SET(IS_IGNORED FALSE)
      FOREACH(pattern ${IGNORE_PATTERNS})
        STRING(REGEX MATCH ${pattern} YES_IGNORE ${path})
        IF (YES_IGNORE)
	  SET(IS_IGNORED TRUE)
        ENDIF()
      ENDFOREACH(pattern)
      IF (NOT IS_IGNORED)
        LIST(APPEND FILES ${path})
      ENDIF(NOT IS_IGNORED)
    ENDIF(IS_SRC)      
  ENDFOREACH(path)

  # Read in list of paths to skip from POTFILES.{skip,ignore}
  READ_FILE_REMOVING_COMMENTS(SKIP_LINES POTFILES.skip)
  READ_FILE_REMOVING_COMMENTS(IGNORE_LINES POTFILES.ignore)

  # Remove the paths that are skipped or ignored
  FOREACH(path ${SKIP_LINES} ${IGNORE_LINES})
    list(REMOVE_ITEM FILES ${path})
  ENDFOREACH()

  
  # CMake sorting different from UNIX sorting. Sort the files
  # here so it is easier for me to compare to the autotools
  # generated POTFILES.in
  STRING(REPLACE ";" "\n" SORT_IN "${FILES}")
  FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in.in "${SORT_IN}")

  EXECUTE_PROCESS(COMMAND "sort"
    INPUT_FILE ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in.in
    OUTPUT_VARIABLE POTFILES_IN
  )
  STRING(REPLACE "\n" ";" POTFILES "${POTFILES_IN}")

  # Write out the final list.
  # intltool-update insists that this file be in the source directory. :-(
  SET(POTFILES_IN_PATH ${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in)
  FILE(WRITE ${POTFILES_IN_PATH} "# This is a list of files which contain translatable strings.
# This file was generated by ../make-gnucash-potfiles.
")

  FOREACH(path ${POTFILES})
    STRING(REGEX MATCH gschema.xml.in.in IS_GSCHEMA ${path})
    IF(IS_GSCHEMA AND NOT WIN32)
      # Force parse type for gsettings files
      SET(path "[type: gettext/gsettings]${path}")
    ENDIF()
    FILE(APPEND ${POTFILES_IN_PATH} "${path}\n")
  ENDFOREACH()

  # These are also added, even though they are outside of src/
  FILE(APPEND ${POTFILES_IN_PATH} "src/gnome/gnucash.appdata.xml.in
src/gnome/gnucash.desktop.in.in
src/libqof/qof/gnc-date.c
src/libqof/qof/qofbookslots.h
doc/tip_of_the_day.list.in
")

ENDFUNCTION()

find_program(INTLTOOL_UPDATE NAMES intltool-update)
IF (${INTLTOOL_UPDATE} STREQUAL "INTLTOOL_UPDATE-NOTFOUND")
  MESSAGE(FATAL_ERROR "Can't find the 'intltool-update' program.")
ENDIF ()

IF(BUILDING_FROM_VCS)

  MAKE_GNUCASH_POTFILES()

  find_program(INTLTOOL_EXTRACT NAMES intltool-extract)
  find_program(XGETTEXT xgettext)

  IF (${INTLTOOL_EXTRACT} STREQUAL "INTLTOOL_EXTRACT-NOTFOUND")
    MESSAGE(FATAL_ERROR "Can't find the 'intltool-extract' program.")
  ENDIF ()

  IF (${XGETTEXT} STREQUAL "XGETTEXT-NOTFOUND")
    MESSAGE(FATAL_ERROR "Can't find the 'xgettext' program.")
  ENDIF ()

  IF (${CMAKE_VERSION} VERSION_GREATER 3.1 AND NOT WIN32)
    EXECUTE_PROCESS(
            COMMAND ${CMAKE_COMMAND_TMP} INTLTOOL_EXTRACT=${INTLTOOL_EXTRACT} XGETTEXT=${XGETTEXT} srcdir=${CMAKE_CURRENT_SOURCE_DIR} ${INTLTOOL_UPDATE} --gettext-package ${PACKAGE} --pot
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            RESULT_VARIABLE GNUCASH_POT_RESULT
    )
    IF(NOT ${GNUCASH_POT_RESULT} STREQUAL "0")
      MESSAGE(FATAL_ERROR "Error when creating gnucash.pot: ${GNUCASH_POT_RESULT}")
    ENDIF()
  ELSE()
    CONFIGURE_FILE(make-gnucash-pot.sh.in make-gnucash-pot.sh)
    EXECUTE_PROCESS(
            COMMAND ${SHELL} ${CMAKE_CURRENT_BINARY_DIR}/make-gnucash-pot.sh
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            RESULT_VARIABLE GNUCASH_POT_RESULT_SHELL
    )
    IF(NOT ${GNUCASH_POT_RESULT_SHELL} STREQUAL "0")
      MESSAGE(FATAL_ERROR "Error when creating gnucash.pot from shell script: ${GNUCASH_POT_RESULT_SHELL}")
    ENDIF()
  ENDIF()

  IF (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/gnucash.pot)
    MESSAGE(FATAL_ERROR "POT file '${CMAKE_CURRENT_SOURCE_DIR}/gnucash.pot' was not successfully created.")
  ENDIF()

ENDIF()

ADD_CUSTOM_TARGET(check-po
        COMMAND ${CMAKE_COMMAND}
           -D INTLTOOL_UPDATE=${INTLTOOL_UPDATE}
           -D PO_DIR=${CMAKE_CURRENT_SOURCE_DIR}
           -P check-po.cmake
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

=== src/CMakeLists.txt ===
# CMakeLists.txt for src/

# ############################################################

# Create config.h

SET (GETTEXT_PACKAGE "gnucash")

SET(GNOME 1)

IF (WIN32)
  SET (HAVE_SCANF_I64D 1)
  SET (HAVE_HTMLHELPW 1)
ENDIF (WIN32)

CHECK_INCLUDE_FILES (X11/Xlib.h HAVE_X11_XLIB_H)
CHECK_INCLUDE_FILES (dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILES (dlfcn.h HAVE_DLFCN_H)
CHECK_INCLUDE_FILES (glob.h HAVE_GLOB_H)
CHECK_INCLUDE_FILES (inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES (limits.h HAVE_LIMITS_H)
CHECK_INCLUDE_FILES (locale.h HAVE_LOCALE_H)
CHECK_INCLUDE_FILES (memory.h HAVE_MEMORY_H)
CHECK_INCLUDE_FILES (stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILES (stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILES (string.h HAVE_STRING_H)
CHECK_INCLUDE_FILES (strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILES (sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES (sys/time.h HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES (sys/times.h HAVE_SYS_TIMES_H)
CHECK_INCLUDE_FILES (sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES (sys/wait.h HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (utmp.h HAVE_UTMP_H)
CHECK_INCLUDE_FILES (wctype.h HAVE_WCTYPE_H)

IF (NOT DISABLE_NLS)
SET(ENABLE_NLS 1)
ENDIF(NOT DISABLE_NLS)

IF (ENABLE_BINRELOC)
  IF (UNIX OR MINGW)
    SET(BR_PTHREAD 1)
  ENDIF(UNIX OR MINGW)
ENDIF(ENABLE_BINRELOC)

IF (UNIX OR MINGW)
  SET (HAVE_BIND_TEXTDOMAIN_CODESET 1)
  SET (HAVE_DCGETTEXT 1)
  SET (HAVE_GETTEXT 1)
  SET (HAVE_GETTIMEOFDAY 1)
  SET (HAVE_GUILE 1)
  SET (HAVE_LIBM 1)
  SET (HAVE_MEMCPY 1)
  SET (STDC_HEADERS 1)
  SET (_ALL_SOURCE 1)
  SET (_GNU_SOURCE 1)
  SET (_POSIX_PTHREAD_SEMANTICS 1)
  SET (_TANDEM_SOURCE 1)
  SET (__EXTENSIONS__ 1)
ENDIF (UNIX OR MINGW)

IF (UNIX)
  SET (HAVE_CHOWN 1)
  SET (HAVE_DLERROR 1)
  SET (HAVE_DLSYM 1)
  SET (HAVE_GETHOSTID 1)
  SET (HAVE_GETHOSTNAME 1)
  SET (HAVE_GETPPID 1)
  SET (HAVE_GETUID 1)
  SET (HAVE_GMTIME_R 1)
  SET (HAVE_LANGINFO_D_FMT 1)
  SET (HAVE_LC_MESSAGES 1)
  SET (HAVE_LIBPTHREAD 1)
  SET (HAVE_LINK 1)
  SET (HAVE_LOCALTIME_R 1)
  SET (HAVE_PTHREAD_MUTEX_INIT 1)
  SET (HAVE_PTHREAD_PRIO_INHERIT 1)
  SET (HAVE_SCANF_LLD 1)
  SET (HAVE_SETENV 1)
  SET (HAVE_STPCPY 1)
  SET (HAVE_STRFMON 1)
  SET (HAVE_STRPTIME 1)
  SET (HAVE_STRUCT_TM_GMTOFF 1)
  SET (HAVE_TIMEGM 1)
  SET (HAVE_TOWUPPER 1)
  SET (GNC_PLATFORM_POSIX 1)
ENDIF (UNIX)

IF (WIN32)
  SET (GNC_PLATFORM_WINDOWS 1)
ENDIF (WIN32)

IF (APPLE)
  # FIXME: HANDLE gtk-mac-integration-gtk2
  SET(GNC_PLATFORM_DARWIN 1)
  SET(GNC_PLATFORM_OSX 1)
  SET(PLATFORM_OSX 1)
  SET(HAVE_OSX_KEYCHAIN 1)

ENDIF(APPLE)

IF(GLIB2_VERSION VERSION_GREATER 2.32.0 OR GLIB2_VERSION VERSION_EQUAL 2.32.0)
  SET(HAVE_GLIB_2_32 1)
ENDIF()

IF(GLIB2_VERSION VERSION_GREATER 2.36.0 OR GLIB2_VERSION VERSION_EQUAL 2.36.0)
  SET(HAVE_GLIB_2_36 1)
ENDIF()

IF(GLIB2_VERSION VERSION_GREATER 2.38.0 OR GLIB2_VERSION VERSION_EQUAL 2.38.0)
  SET(HAVE_GLIB_2_38 1)
ENDIF()

IF(DISABLE_DEPRECATED_GNOME)
  SET(GNOME_DISABLE_DEPRECATED 1)
ENDIF(DISABLE_DEPRECATED_GNOME)

IF(DISABLE_DEPRECATED_GTK)
  SET(GTK_DISABLE_DEPRECATED 1)
  SET(GDK_DISABLE_DEPRECATED 1)
  SET(GDK_PIXMAP_DISABLE_DEPRECATED 1)
ENDIF(DISABLE_DEPRECATED_GTK)

IF(DISABLE_DEPRECATED_GLIB)
  SET(G_DISABLE_DEPRECATED 1)
ENDIF(DISABLE_DEPRECATED_GLIB)

ADD_DEFINITIONS (-DHAVE_CONFIG_H)

SET (CONFIG_H ${CMAKE_CURRENT_BINARY_DIR}/config.h)
CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in ${CONFIG_H})

IF (BUILDING_FROM_VCS)
  SET (SWIG_RUNTIME_H ${CMAKE_CURRENT_BINARY_DIR}/swig-runtime.h)
ELSE()
  SET (SWIG_RUNTIME_H ${CMAKE_CURRENT_SOURCE_DIR}/swig-runtime.h)
ENDIF()


SET(SCHEME_INSTALLED_SOURCE_DIR ${CMAKE_INSTALL_PREFIX}/share/gnucash/scm)
SET(SCHEME_INSTALLED_CACHE_DIR ${CMAKE_INSTALL_PREFIX}/lib/gnucash/scm/ccache/${GUILE_EFFECTIVE_VERSION})

# The subdirectories
ADD_SUBDIRECTORY (libqof)
ADD_SUBDIRECTORY (core-utils)
ADD_SUBDIRECTORY (gnc-module)
ADD_SUBDIRECTORY (engine)
ADD_SUBDIRECTORY (backend)
ADD_SUBDIRECTORY (app-utils)
ADD_SUBDIRECTORY (import-export)

IF (WITH_GNUCASH)
  ADD_SUBDIRECTORY (bin)
  ADD_SUBDIRECTORY (business)
  ADD_SUBDIRECTORY (cmake_modules)
  ADD_SUBDIRECTORY (debug)
  ADD_SUBDIRECTORY (doc)
  ADD_SUBDIRECTORY (gnome)
  ADD_SUBDIRECTORY (gnome-utils)
  ADD_SUBDIRECTORY (gnome-search)
  ADD_SUBDIRECTORY (html)
  ADD_SUBDIRECTORY (optional)
  ADD_SUBDIRECTORY (plugins)
  ADD_SUBDIRECTORY (pixmaps)
  ADD_SUBDIRECTORY (python)
  ADD_SUBDIRECTORY (quotes)
  ADD_SUBDIRECTORY (register)
  ADD_SUBDIRECTORY(report)
  ADD_SUBDIRECTORY (scm)
  ADD_SUBDIRECTORY (tax)
  ADD_SUBDIRECTORY (test-core)
ENDIF (WITH_GNUCASH)

IF (WITH_CUTECASH)
  ADD_SUBDIRECTORY (gnc)
ENDIF (WITH_CUTECASH)

SET(src_EXTRA_DIST
        base-typemaps.i
        config.h.cmake.in
        gnc-test-env.pl
        guile-mappings.h
        platform.h
        README
        README.modules)

SET_LOCAL_DIST(src_DIST_local CMakeLists.txt Makefile.am ${src_EXTRA_DIST})

SET(src_DIST ${src_DIST_local} ${app_utils_DIST} ${backend_DIST} ${bin_DIST} ${business_DIST} ${cmake_modules_DIST}
             ${core_utils_DIST} ${debug_DIST} ${doc_DIST} ${engine_DIST} ${gnc_module_DIST} ${gnome_DIST} ${gnome_search_DIST}
             ${gnome_utils_DIST} ${html_DIST} ${import_export_DIST} ${libqof_DIST} ${optional_DIST} ${plugins_DIST} ${pixmaps_DIST} ${python_DIST}
             ${quotes_DIST} ${register_DIST} ${report_DIST} ${scm_DIST} ${tax_DIST} ${test_core_DIST} PARENT_SCOPE)

=== test-templates/CMakeLists.txt ===

SET_DIST_LIST(test_templates_DIST CMakeLists.txt Makefile.am Makefile.decl)

=== util/CMakeLists.txt ===

SET_DIST_LIST(util_DIST gnc-vcs-info guile.c CMakeLists.txt)

=== accounts/C/CMakeLists.txt ===


SET(account_DATA
  acctchrt_brokerage.gnucash-xea
  acctchrt_business.gnucash-xea
  acctchrt_carloan.gnucash-xea
  acctchrt_cdmoneymkt.gnucash-xea
  acctchrt_checkbook.gnucash-xea
  acctchrt_childcare.gnucash-xea
  acctchrt_common.gnucash-xea
  acctchrt_eduloan.gnucash-xea
  acctchrt_fixedassets.gnucash-xea
  acctchrt_homeloan.gnucash-xea
  acctchrt_homeown.gnucash-xea
  acctchrt_otherloan.gnucash-xea
  acctchrt_renter.gnucash-xea
  acctchrt_retiremt.gnucash-xea
  acctchrt_spouseinc.gnucash-xea
  acctchrt_spouseretire.gnucash-xea)

SET_DIST_LIST(C_DIST ${account_DATA} acctchrt_full.gnucash-xea Makefile.am CMakeLists.txt)

INSTALL(FILES ${account_DATA} DESTINATION ${ACCOUNTS_INSTALL_DIR}/C)
FILE(COPY ${account_DATA} DESTINATION ${ACCOUNTS_BUILD_DIR}/C)

=== accounts/cs/CMakeLists.txt ===
SET(account_DATA
  acctchrt_brokerage.gnucash-xea
  acctchrt_carloan.gnucash-xea
  acctchrt_cdmoneymkt.gnucash-xea
  acctchrt_childcare.gnucash-xea
  acctchrt_common.gnucash-xea
  acctchrt_currency.gnucash-xea
  acctchrt_eduloan.gnucash-xea
  acctchrt_fixedassets.gnucash-xea
  acctchrt_homeloan.gnucash-xea
  acctchrt_homeown.gnucash-xea
  acctchrt_otherloan.gnucash-xea
  acctchrt_renter.gnucash-xea
  acctchrt_retiremt.gnucash-xea
  acctchrt_spouseinc.gnucash-xea
  acctchrt_spouseretire.gnucash-xea)

SET_DIST_LIST(CS_DIST ${account_DATA} Makefile.am CMakeLists.txt)

INSTALL(FILES ${account_DATA} DESTINATION ${ACCOUNTS_INSTALL_DIR}/cs)
FILE(COPY ${account_DATA} DESTINATION ${ACCOUNTS_BUILD_DIR}/cs)

=== debian/changelog ===
gnucash (1:2.6.19-1) unstable; urgency=medium

  * New upstream release [December 2017].

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 09 Apr 2018 01:39:23 +1000

=== debian/control ===
Source: gnucash
Section: gnome
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Standards-Version: 4.1.1
Build-Depends: debhelper (>= 10), intltool, pkg-config, dh-python,
 guile-2.0-dev,
 imagemagick,
 libaqbanking-dev (>= 5.6.0beta),
 libdbi-dev,
 libdbd-sqlite3,
 libglib2.0-dev (>= 2.26),
 libsecret-1-dev,
 libgnomecanvas2-dev,
 libgoffice-0.8-dev,
 libgtk2.0-dev (>= 2.24),
 libgwengui-gtk2-dev,
 libofx-dev,
 libwebkitgtk-dev,
 libxml2-dev,
 libxslt1-dev,
 python,
 python-dev,
 xsltproc,
 zlib1g-dev
## Needed by tests:
 ,locales-all
Build-Conflicts: guile-1.8
Homepage: http://www.gnucash.org/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-gnucash/gnucash.git
Vcs-Git: https://anonscm.debian.org/git/pkg-gnucash/gnucash.git

Package: gnucash
Architecture: any
Depends: gnucash-common (= ${source:Version}), ${shlibs:Depends},
  ${aqbanking:Depends}, ${misc:Depends}, ${perl:Depends}, guile-2.0,
  libfinance-quote-perl, libwww-perl, libhtml-tree-perl,
  libhtml-tableextract-perl, libcrypt-ssleay-perl, libdate-manip-perl
Suggests: libdbd-mysql, libdbd-pgsql, libdbd-sqlite3
Recommends: gnucash-docs
           ,python-gnucash
           ,yelp
           ,dbus (>= 1.8~) | dbus-x11
Breaks: gnucash-common (<< 1:2.4.8-1~)
Replaces: gnucash-common (<< 1:2.4.8-1~)
Description: personal and small-business financial-accounting software
 Gnucash provides accounting functions suitable for use by small businesses and
 individuals. It can track finances in multiple accounts, keeping running and
 reconciled balances. There is support for customer, vendor and employee
 processing. It has an X based graphical user interface, double entry, a
 hierarchy of accounts, expense accounts (categories), and can import Quicken
 QIF files and OFX files.

Package: gnucash-common
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Recommends: gnucash (>= ${source:Version})
Breaks: gnucash (<< 2.4.0-1~)
Replaces: gnucash (<< 2.4.0-1~)
Description: common files for the financial-accounting software Gnucash
 Gnucash provides accounting functions suitable for use by small businesses and
 individuals. It can track finances in multiple accounts, keeping running and
 reconciled balances. There is support for customer, vendor and employee
 processing. It has an X based graphical user interface, double entry, a
 hierarchy of accounts, expense accounts (categories), and can import Quicken
 QIF files and OFX files.
 .
 This package contains the architecture independent parts of Gnucash. It should
 not be installed directly, but is pulled in automatically by the dependencies
 of the Gnucash package.

Package: python-gnucash
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-gtk2
Description: Gnucash interface for Python
 Gnucash provides accounting functions suitable for use by small businesses and
 individuals. It can track finances in multiple accounts, keeping running and
 reconciled balances. There is support for customer, vendor and employee
 processing. It has an X based graphical user interface, double entry, a
 hierarchy of accounts, expense accounts (categories), and can import Quicken
 QIF files and OFX files.
 .
 This package contains the Python bindings for Gnucash which allow you to read
 and manipulate Gnucash data files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

# Hack for Gnucash build system
export BUILDING_FROM_SVN=$(if $(wildcard autogen.sh),yes,no)

# reduce overlinking
export DEB_LDFLAGS_MAINT_APPEND += -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --with python2,autoreconf,aqbanking

override_dh_auto_clean:
	find . -type l -exec rm -v \{\} \;
	rm -fv debian/gnucash-icon-32x32.xpm
	dh_auto_clean

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure -- \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/gnucash \
		--infodir=/noinst \
		--mandir=/noinst \
		--docdir=/noinst \
		--disable-static \
		--enable-dbi \
		--enable-ofx \
		--enable-aqbanking \
		--enable-locale-specific-tax \
		--enable-python

# override this call, so we do not use parallelization
# see https://bugzilla.gnome.org/show_bug.cgi?id=644896
override_dh_auto_install:
	dh_auto_install --max-parallel=1

override_dh_install:
	convert src/pixmaps/gnucash-icon-32x32.png debian/gnucash-icon-32x32.xpm
	pod2man -s1 --stderr --utf8 debian/tmp/usr/bin/gnc-fq-check debian/tmp/gnc-fq-check.1
	find debian/tmp/usr/lib -name \*.la -exec rm -v \{\} \;
	dh_install

override_dh_auto_test:
	dh_auto_test --max-parallel=1

override_dh_strip:
	dh_strip --dbgsym-migration='gnucash-dbg (<< 1:2.6.13~)'

override_dh_python2:
	dh_python2 --no-guessing-versions -V $(shell pyversions -dv)

# Generate an shlibs files because otherwise dpkg-shlibdeps will fail on
# python-gnucash. But do not distribute the shlibs file in the package, since
# this creates a lot of lintian warning (many dynamic libraries do not have a
# correct SOVERSION).
override_dh_makeshlibs:
	dh_makeshlibs -n --version-info="gnucash (= ${DEB_VERSION})"

override_dh_shlibdeps:
	dh_shlibdeps
	rm -f debian/gnucash/DEBIAN/shlibs

=== debian/watch ===
version=4

## https://qa.debian.org/watch/sf.php/gnucash/

opts="\
uversionmangle=s{\-\d}{}\
"  http://sf.net/gnucash/gnucash-(\d+\.\d+\.\d+)(?:-\d)?\.tar\.bz2
